# plugin to force SketchUp to save a preview jpeg image whenever
# a skp file is saved.  This image is compatible with my
# QuickLook thumbnail viewer.  

require "sketchup.rb"

class PreviewMaker < Sketchup::ModelObserver
  def onSaveModel(theModel)
    # puts "PreviewMaker.onSaveModel"
    basePath = theModel.path[0..-5]
    #thumbFile = basePath + ".tn.png"
    previewFile = basePath + ".pv.jpg"
   # thumbKeys = {
   #   :filename => thumbFile,
   #   :width => 128,
   #   :height =>128,
   # }
    # width, height, and compression were chosen to provide a
    # reasonably clean representation at all thumbnail scales
    # without requiring an excessively large image file.
    previewKeys = {
      :filename => previewFile,
      :width => 800,
      :height => 600,
      :compression => 0.3
    }
    theView = theModel.active_view
    #theView.write_image(thumbKeys)
    theView.write_image(previewKeys)
  end
end

class NewModel < Sketchup::AppObserver
  def onNewModel(model)
    model.add_observer(PreviewMaker.new())
  end

  def onOpenModel(model)
    model.add_observer(PreviewMaker.new())
  end
end

Sketchup.add_observer(NewModel.new())
